#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>

const char *ssid = "XXXXXXXXXXXXX";
const char *password = "XXXXXXXXXXXXX";

const int motorPin1 = D1;           // IN1 на драйвере ULN2003
const int motorPin2 = D2;           // IN2 на драйвере ULN2003 
const int motorPin3 = D3;           // IN3 на драйвере ULN2003
const int motorPin4 = D4;           // IN4 на драйвере ULN2003

// полушаговый режим – 8 ступеней импульсов на 1 шаг
int pole1[] ={0,0,0,0, 0,1,1,1, 0};
int pole2[] ={0,0,0,1, 1,1,0,0, 0};
int pole3[] ={0,1,1,1, 0,0,0,0, 0};
int pole4[] ={1,1,0,0, 0,0,0,1, 0};


int poleStep = 0; 
int  dirStatus = 3;                 // Статус СТОП
const int rotation_speed = 1;       // Скорость вращения 1 - самая высокая  | 70 - Очень медленно


String buttonTitle1[] ={"против часовой", "по часовой"};
String buttonTitle2[] ={"против часовой", "по часовой"};
String argId[] ={"ccw", "cw"};






ESP8266WebServer server(80);

// Вывод HTML страницы
void handleRoot() {
 String HTML ="<!DOCTYPE html>\       
  <html>\
  <head>\
  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\
  \t\n<title>Управление шаговым двигателем 28BYJ-48</title>\
  \t\n<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">\
  \n<style>\
 \nhtml,body{\t\nwidth:100%\;\nheight:100%\;\nmargin:0}\n*{box-sizing:border-box}\n.colorAll{\n\tbackground-color:#90ee90}\n.colorBtn{\n\tbackground-color:#add8e6}\n.angleButtdon,a{\n\tfont-size:30px\;\nborder:1px solid #ccc\;\ndisplay:table-caption\;\npadding:7px 10px\;\ntext-decoration:none\;\ncursor:pointer\;\npadding:5px 6px 7px 10px}a{\n\tdisplay:block}\n.btn{\n\tmargin:5px\;\nborder:none\;\ndisplay:inline-block\;\nvertical-align:middle\;\ntext-align:center\;\nwhite-space:nowrap}\n";
   
  HTML +="</style></head><body><h3 style=\"text-align:center;\">Управление шаговым двигателем <br />";
  HTML +="<font style=\"font-size:50px\">28BYJ-48</font></h3>";
   if(dirStatus ==2){
    HTML +="<div style=\"background-color:#66f3f5; font-size:20px; text-align:center;\">По часовой</div>"; 
    HTML +="<div><br /></div>";   
   }else if(dirStatus ==1){
    HTML +="<div style=\"background-color:#66f3f5; font-size:20px; text-align:center;\">Против часовой</div>";
    HTML +="<div><br /></div>";      
   }else{
    HTML +="<div style=\"background-color:#66f3f5; font-size:20px; text-align:center;\">Стоп</div>";  
    HTML +="<div><br /></div>";  
   }
      if(dirStatus ==1){
        HTML +="\t<div class=\"btn\" style=\"width: 310px\"><a class=\"angleButton\" style=\"background-color:#f56464\"  href=\"/motor?";
        HTML += argId[0];
        HTML += "=off\">";
        HTML +=buttonTitle1[0]; //motor ON title
      }else{
        HTML +="\t<div class=\"btn\" style=\"width: 310px\"><a class=\"angleButton \" style=\"background-color:#90ee90\"  href=\"/motor?";  
         HTML += argId[0];
        HTML += "=on\">";       
        HTML +=buttonTitle2[0];//motor OFF title   
      }   
     HTML +="</a>\t\n\t</div>\n\n";  
           
      if(dirStatus ==2){
        HTML +="\t<div class=\"btn\" style=\"width: 310px\"><a class=\"angleButton\" style=\"background-color:#f56464\"  href=\"/motor?";
        HTML += argId[1];
        HTML += "=off\">";
        HTML +=buttonTitle1[1]; //motor ON title
      }else{
        HTML +="\t<div class=\"btn\" style=\"width: 310px\"><a class=\"angleButton \" style=\"background-color:#90ee90;\"  href=\"/motor?";  
         HTML += argId[1];
        HTML += "=on\">";       
        HTML +=buttonTitle2[1];//motor OFF title   
      }   
     HTML +="</a>\t\n\t</div>\n\n";     


        HTML +="\t<div class=\"btn\" style=\"width: 310px\"><a class=\"angleButton\" style=\"background-color:#000000; color:#ffffff\"  href=\"/motor?";
        HTML += argId[1];
        HTML += "=off\">";
        HTML +="СТОП";                        //Остановка
     HTML +="</a>\t\n\t</div>\n\n"; 
   

  HTML +="\t\n</body>\n</html>\n";
  server.send(200, "text/html", HTML);  
}

void handleNotFound() {
  String message = "File Not Found\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message += (server.method() == HTTP_GET) ? "GET" : "POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";

  for (uint8_t i = 0; i < server.args(); i++) {
    message += " " + server.argName(i) + ": " + server.arg(i) + "\n";
  }

  server.send(404, "text/plain", message);
}

void setup(void) {
 
 pinMode(motorPin1, OUTPUT);                          //Устанавливаем motorPin1 как выход
 pinMode(motorPin2, OUTPUT);                          //Устанавливаем motorPin2 как выход  
 pinMode(motorPin3, OUTPUT);                          //Устанавливаем motorPin3 как выход  
 pinMode(motorPin4, OUTPUT);                          //Устанавливаем motorPin4 как выход 

 
  Serial.begin(115200);                               //Инициализируем монитор порта
  Serial.println("Управление шаговым двигателем 28BYJ-48");
    
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  Serial.println("");
  
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.print("Соединились с ");
  Serial.println(ssid);
  Serial.print("IP адрес: http://");
  Serial.println(WiFi.localIP());

  server.on("/", handleRoot);
  server.on("/motor", HTTP_GET, motorControl);           
  server.onNotFound(handleNotFound);
  server.begin();
  Serial.println("HTTP сервер запущен");

}

void loop(void) {
  server.handleClient();
if(dirStatus ==1){ 
   poleStep++; 
    driveStepper(poleStep);    
 }else if(dirStatus ==2){ 
   poleStep--; 
    driveStepper(poleStep);    
 }else{
  driveStepper(8);   
 }
 if(poleStep>7){ 
   poleStep=0; 
 } 
 if(poleStep<0){ 
   poleStep=7; 
 } 

   delay(rotation_speed);

}

void motorControl() {
    if(server.arg(argId[0]) == "on")
    {
      dirStatus = 1;                    // Против часовой
               
    }else if(server.arg(argId[0]) == "off"){
      dirStatus = 3;                    // Остановка
          
    }else if(server.arg(argId[1]) == "on"){
      dirStatus = 2;                    // По часовой  
          
    }else if(server.arg(argId[1]) == "off"){
      dirStatus = 3;                    // Остановка
          
    }   

  handleRoot();
}

void driveStepper(int c)
{
     digitalWrite(motorPin1, pole1[c]);  
     digitalWrite(motorPin2, pole2[c]); 
     digitalWrite(motorPin3, pole3[c]); 
     digitalWrite(motorPin4, pole4[c]);   
}
